/*
  +----------------------------------------------------------------------+
  | PHP Version 5                                                        |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006,2007 San Tai (Vanilla) Hsu                        |
  +----------------------------------------------------------------------+
  | This source file is subject to the BSD license, that is bundled with |
  | this package in the file LICENSE                                     |
  +----------------------------------------------------------------------+
  | Author:  San Tai (Vanilla) Hsu (vanilla@FreeBSD.org>                 |
  +----------------------------------------------------------------------+
*/
/* $Header$ */

extern "C" {
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "php_ini.h"
#include "ext/standard/info.h"
#include "php_cTemplate.h"
#include "zend_exceptions.h"
#include "zend_object_handlers.h"
#include "zend_hash.h"
}
#include <string>
#include "google/template.h"
#include "google/template_from_string.h"
#include "google/template_dictionary.h"

using namespace std;
using namespace google;

class cTemplateTpl
{
public:
    Template *t;
    TemplateFromString *s;
    unsigned int is_from_string:1;

    cTemplateTpl();
    ~cTemplateTpl();
};

class cTemplateDict
{
public:
    TemplateDictionary d;
    TemplateDictionary *p;
    unsigned int is_root:1;

    cTemplateDict();
    ~cTemplateDict();
};

cTemplateTpl::cTemplateTpl () : t (), s ()
{
}

cTemplateTpl::~cTemplateTpl ()
{
    if (s != NULL)
    {
        s->ClearCache ();
        delete s;
    }

    if (t != NULL)
    {
        t->ClearCache ();
        delete t;
    }
}

typedef struct
{
    zend_object *zo;
    unsigned int refcount;
    cTemplateTpl *obj;
} php_cTemplateTpl;

typedef struct
{
    zend_object *zo;
    unsigned int refcount;
    cTemplateDict *obj;
} php_cTemplateDict;

/*
 * vim:ts=4:expandtab:sw=4
 */
